﻿/*
 *RSP Software 2008 , November 
 * 
 * 
 * */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using RSPEncrypt;

namespace sample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            StringBuilder soc = new StringBuilder (300);

            Encrypt.Version(soc);
            
            this.Text = "RSP .Net Encrypt " + soc.ToString() + " - Sample ";

            Encrypt.SetProcessorPriority(4);//normal
/*
1 = IDLE
2 = LOWEST
3 = BELOW_NORMAL
4 = NORMAL
5 = ABOVE_NORMAL
6 = HIGHEST
7 = TIME_CRITICAL
*/

        }

        private void button1_Click(object sender, EventArgs e)
        {
            of.FileName = "";
            of.ShowDialog();

            if ("" != of.FileName)
            {

                input_.Text = of.FileName;


            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            sf.FileName = "";
            sf.ShowDialog();

            if ("" != sf.FileName)
            {

                output_.Text = sf.FileName;


            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            sf.FileName = "";
            sf.ShowDialog();

            if ("" != sf.FileName)
            {

                exit_.Text = sf.FileName;


            }
        }
        private void Progress(int value)
        {

            pb.Value = value;
        }
        private void Finished(int ErrorCode, string Value)
        {

            label3.Text = "Status: " + ErrorCode + " " + Value;
            pb.Value = 100;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {

            int ret;

            ret = Encrypt.GetStatus();

            if (0 == ret)
            {
                ret = Encrypt.GetReturnValue();

                switch (ret)
                {
                    case 0:
                        Finished(0, "No error");
                        break;
                    case 1:
                        Finished(1, "Unable to open the input file");
                        break;
                    case 2:

                        Finished(2, "Unable to open the output file");
                        break;
                    case 3:
                        Finished(3, "Invalid encrypted file");
                        break;
                    case 4:
                        Finished(4, "CRC data error!");
                        break;

                }
                timer1.Enabled = false;
            }
            else
            {
                Progress(Encrypt.GetProgress());

            }



        }

        private void button4_Click(object sender, EventArgs e)
        {
            label3.Text = "";
            int ret=0;
            if (rc4.CheckState == CheckState.Checked)
            {
               ret= Encrypt.NewEncryptFileRC4(input_.Text, output_.Text, pass.Text);
            }


            if (aes.CheckState == CheckState.Checked)
            {
               ret= Encrypt.NewEncryptFileAES (input_.Text, output_.Text, pass.Text);
            }


            if (aes_ctr.CheckState == CheckState.Checked)
            {
               ret= Encrypt.NewEncryptFileAES_CTR (input_.Text, output_.Text, pass.Text);
            }

            if (0 == ret)
            {
                timer1.Enabled = true;
            }
            else
            {
                StringBuilder soc = new StringBuilder(300);
                Encrypt.PrintError(ret, soc);
           label3.Text = "Status: " + ret.ToString() + " " + soc.ToString();
            }

        }

        private void rc4_MouseUp(object sender, MouseEventArgs e)
        {
            rc4.CheckState = CheckState.Checked;
            aes.CheckState = CheckState.Unchecked;
            aes_ctr.CheckState = CheckState.Unchecked;
        }

        private void aes_MouseUp(object sender, MouseEventArgs e)
        {
            rc4.CheckState = CheckState.Unchecked;
            aes.CheckState = CheckState.Checked;
            aes_ctr.CheckState = CheckState.Unchecked;
        }

        private void aes_ctr_MouseUp(object sender, MouseEventArgs e)
        {
            rc4.CheckState = CheckState.Unchecked;
            aes.CheckState = CheckState.Unchecked;
            aes_ctr.CheckState = CheckState.Checked;
        }

        private void button5_Click(object sender, EventArgs e)
        {
            label3.Text = "";
            int ret = 0;
            if (rc4.CheckState == CheckState.Checked)
            {
                ret = Encrypt.NewDecryptFileRC4 (output_.Text,exit_.Text , pass.Text);
            }


            if (aes.CheckState == CheckState.Checked)
            {
                ret = Encrypt.NewDecryptFileAES(output_.Text, exit_.Text, pass.Text);
            }


            if (aes_ctr.CheckState == CheckState.Checked)
            {
                ret = Encrypt.NewDecryptFileAES_CTR(output_.Text, exit_.Text, pass.Text);
            }

            if (0 == ret)
            {
                timer1.Enabled = true;
            }
            else
            {
                StringBuilder soc = new StringBuilder(300);
                Encrypt.PrintError(ret, soc);
                label3.Text = "Status: " + ret.ToString() + " " + soc.ToString();
            }
        }

        private void button6_Click(object sender, EventArgs e)
        {
            Encrypt.PauseExecution();
        }

        private void button7_Click(object sender, EventArgs e)
        {
            Encrypt.ResumeExecution();
        }

        private void button8_Click(object sender, EventArgs e)
        {
            Encrypt.CancelExecution();
        }

        private void button9_Click(object sender, EventArgs e)
        {
            int ret=0;

            StringBuilder soc = new StringBuilder(in_.Text.Length * 3);
            if (rc4.CheckState == CheckState.Checked)
            {
                ret = Encrypt.EncryptStringRC4(in_.Text, soc, pass.Text);
                out_.Text = soc.ToString();

            }


            if (aes.CheckState == CheckState.Checked)
            {
                ret = Encrypt.EncryptStringAES(in_.Text, soc, pass.Text);
                out_.Text = soc.ToString();
            }


            if (aes_ctr.CheckState == CheckState.Checked)
            {
                ret = Encrypt.EncryptStringAES_CTR (in_.Text, soc, pass.Text);
                out_.Text = soc.ToString();
            }

            
        }

        private void button10_Click(object sender, EventArgs e)
        {
            int ret = 0;

            StringBuilder soc = new StringBuilder(out_.Text.Length * 3);
            if (rc4.CheckState == CheckState.Checked)
            {
                ret = Encrypt.DecryptStringRC4 (out_.Text, soc, pass.Text);
                un_.Text = soc.ToString();

            }


            if (aes.CheckState == CheckState.Checked)
            {
                ret = Encrypt.DecryptStringAES (out_.Text, soc, pass.Text);
                un_.Text = soc.ToString();
            }


            if (aes_ctr.CheckState == CheckState.Checked)
            {
                ret = Encrypt.DecryptStringAES_CTR (out_.Text, soc, pass.Text);
                un_.Text = soc.ToString();
            }

        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {

            Encrypt.About();

        }
    }
}


/*

 * Thanks for using our software

*/